/*
With Verilog-XL static linking, compile with cr_vlog and add the
-Dverilogxl switch to the C compile. See the end of the file for the
veriusertfs structure for veriuser.c.
*/

#include "veriuser.h"	/* Base Verilog PLI definitions		*/
#ifdef verilogxl
#include "vxl_veriuser.h"
#endif

char *veriuser_version_str = "<< File read functions are linked in >>\n";

int (*endofcompile_routines[])() = 
{
    0 /*** final entry must be 0 ***/
};

bool err_intercept(level,facility,code)
int level; char *facility; char *code;
{ return(true); }


extern int fio_size32();
extern int fio_fopen_check();
extern int fio_fopen_call();
extern int fio_fopen_misc();
extern int fio_fclose_check();
extern int fio_fclose_call();
extern int fio_fclose_misc();
extern int fio_fgets_check();
extern int fio_fgets_call();
extern int fio_gets_check();
extern int fio_gets_call();
extern int fio_fgetc_check();
extern int fio_fgetc_call();
extern int fio_getchar_check();
extern int fio_getchar_call();
extern int fio_ungetc_check();
extern int fio_ungetc_call();
extern int fio_feof_check();
extern int fio_feof_call();
extern int fio_ferror_check();
extern int fio_ferror_call();
extern int fio_fscanf_check();
extern int fio_fscanf_call();
extern int fio_fscanf_misc();
extern int fio_sscanf_check();
extern int fio_sscanf_call();
extern int fio_sscanf_misc();
extern int fio_scanf_check();
extern int fio_scanf_call();
extern int fio_scanf_misc();
extern int fio_ftell_check();
extern int fio_ftell_call();
extern int fio_fseek_check();
extern int fio_fseek_call();
extern int fio_fread_check();
extern int fio_fread_call();
extern int fio_sformat_check();
extern int fio_sformat_call();
extern int fio_sformat_misc();
extern int fio_swrite_check();
extern int fio_swrite_call();
extern int fio_swrite_misc();
extern int fio_fprintf_check();
extern int fio_fprintf_call();
extern int fio_fprintf_misc();
extern int fio_fflush_check();
extern int fio_fflush_call();
extern int fio_fputc_check();
extern int fio_fputc_call();


/******************************************************************************
 veriusertfs structure
******************************************************************************/

s_tfcell veriusertfs[] = {
  /*** Template for an entry:
    { usertask|userfunction, data,
        checktf(), sizetf(), calltf(), misctf(),
        "$tfname", forwref?, Vtool?, ErrMsg? },
    Example:
    { usertask, 0, my_check, 0, my_func, my_misctf, "$my_task" },
    ***/
    {userfunction, 97, fio_fopen_check,  fio_size32, fio_fopen_call,   fio_fopen_misc,   "$fopena"},
    {userfunction, 114,fio_fopen_check,  fio_size32, fio_fopen_call,   fio_fopen_misc,   "$fopenr"},
    {userfunction, 119,fio_fopen_check,  fio_size32, fio_fopen_call,   fio_fopen_misc,   "$fopenw"},
    {userfunction, 97, fio_fclose_check, fio_size32, fio_fclose_call,  0,                "$fclosea"},
    {userfunction, 114,fio_fclose_check, fio_size32, fio_fclose_call,  0,                "$fcloser"},
    {userfunction, 119,fio_fclose_check, fio_size32, fio_fclose_call,  0,                "$fclosew"},
    {userfunction, 0,  fio_fgets_check,  fio_size32, fio_fgets_call,   0,                "$fgets"},
    {userfunction, 0,  fio_gets_check,   fio_size32, fio_gets_call,    0,                "$gets"},
    {userfunction, 0,  fio_fgetc_check,  fio_size32, fio_fgetc_call,   0,                "$fgetc"},
    {userfunction, 0,  fio_getchar_check,fio_size32, fio_getchar_call, 0,                "$getchar"},
    {userfunction, 0,  fio_ungetc_check, fio_size32, fio_ungetc_call,  0,                "$ungetc"},
    {userfunction, 0,  fio_feof_check,   fio_size32, fio_feof_call,    0,                "$feof"},
    {userfunction, 0,  fio_ferror_check, fio_size32, fio_ferror_call,  0,                "$ferror"},
#ifdef scanf_task
    {userfunction, 0,  fio_fscanf_check, 0,          fio_fscanf_call,  fio_fscanf_misc,  "$fscanf"},
    {userfunction, 0,  fio_sscanf_check, 0,          fio_sscanf_call,  fio_sscanf_misc,  "$sscanf"},
    {userfunction, 0,  fio_scanf_check,  0,          fio_scanf_call,   fio_scanf_misc,   "$scanf"},
#else
    {userfunction, 0,  fio_fscanf_check, fio_size32, fio_fscanf_call,  fio_fscanf_misc,  "$fscanf"},
    {userfunction, 0,  fio_sscanf_check, fio_size32, fio_sscanf_call,  fio_sscanf_misc,  "$sscanf"},
    {userfunction, 0,  fio_scanf_check,  fio_size32, fio_scanf_call,   fio_scanf_misc,   "$scanf"},
#endif
    {userfunction, 0,  fio_ftell_check,  fio_size32, fio_ftell_call,   0,                "$ftell"},
    {userfunction, 0,  fio_fseek_check,  fio_size32, fio_fseek_call,   0,                "$fseek"},
    {userfunction, 0,  fio_fread_check,  fio_size32, fio_fread_call,   0,                "$fread"},
    {userfunction, 1,  fio_sformat_check,fio_size32, fio_sformat_call, fio_sformat_misc, "$sprintf"},
    {userfunction, 2,  fio_sformat_check,fio_size32, fio_sformat_call, fio_sformat_misc, "$sformat"},
    {userfunction, 0,  fio_swrite_check, fio_size32, fio_swrite_call,  fio_swrite_misc,  "$swrite"},
    {userfunction, 0,  fio_fprintf_check,fio_size32, fio_fprintf_call, fio_fprintf_misc, "$fprintf"},
    {userfunction, 0,  fio_fflush_check, fio_size32, fio_fflush_call,  0,                "$fflush"},
    {userfunction, 0,  fio_fputc_check,  fio_size32, fio_fputc_call,   0,                "$fputc"},
    {0}                           /*** final entry must be 0 ***/
};


#ifdef MTI
void init_usertfs() {
  p_tfcell usertf;
  for (usertf = veriusertfs; usertf; usertf++) {
    if (usertf->type == 0)
      return;
    mti_RegisterUserTF(usertf);
  }
}
#endif
